/**
 * generated by Xtext 2.25.0
 */
package tdt4250.xjava.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import tdt4250.xjava.FieldDeclaration;
import tdt4250.xjava.MethodDeclaration;
import tdt4250.xjava.TypeDeclaration;
import tdt4250.xjava.TypeReference;
import tdt4250.xjava.XjavaPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Type Declaration</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tdt4250.xjava.impl.TypeDeclarationImpl#getName <em>Name</em>}</li>
 *   <li>{@link tdt4250.xjava.impl.TypeDeclarationImpl#getSuperTypeRef <em>Super Type Ref</em>}</li>
 *   <li>{@link tdt4250.xjava.impl.TypeDeclarationImpl#getFieldDecls <em>Field Decls</em>}</li>
 *   <li>{@link tdt4250.xjava.impl.TypeDeclarationImpl#getMethodDecls <em>Method Decls</em>}</li>
 * </ul>
 *
 * @generated
 */
public class TypeDeclarationImpl extends MinimalEObjectImpl.Container implements TypeDeclaration
{
  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The cached value of the '{@link #getSuperTypeRef() <em>Super Type Ref</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSuperTypeRef()
   * @generated
   * @ordered
   */
  protected TypeReference superTypeRef;

  /**
   * The cached value of the '{@link #getFieldDecls() <em>Field Decls</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFieldDecls()
   * @generated
   * @ordered
   */
  protected EList<FieldDeclaration> fieldDecls;

  /**
   * The cached value of the '{@link #getMethodDecls() <em>Method Decls</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMethodDecls()
   * @generated
   * @ordered
   */
  protected EList<MethodDeclaration> methodDecls;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TypeDeclarationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return XjavaPackage.Literals.TYPE_DECLARATION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, XjavaPackage.TYPE_DECLARATION__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public TypeReference getSuperTypeRef()
  {
    return superTypeRef;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetSuperTypeRef(TypeReference newSuperTypeRef, NotificationChain msgs)
  {
    TypeReference oldSuperTypeRef = superTypeRef;
    superTypeRef = newSuperTypeRef;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, XjavaPackage.TYPE_DECLARATION__SUPER_TYPE_REF, oldSuperTypeRef, newSuperTypeRef);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setSuperTypeRef(TypeReference newSuperTypeRef)
  {
    if (newSuperTypeRef != superTypeRef)
    {
      NotificationChain msgs = null;
      if (superTypeRef != null)
        msgs = ((InternalEObject)superTypeRef).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - XjavaPackage.TYPE_DECLARATION__SUPER_TYPE_REF, null, msgs);
      if (newSuperTypeRef != null)
        msgs = ((InternalEObject)newSuperTypeRef).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - XjavaPackage.TYPE_DECLARATION__SUPER_TYPE_REF, null, msgs);
      msgs = basicSetSuperTypeRef(newSuperTypeRef, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, XjavaPackage.TYPE_DECLARATION__SUPER_TYPE_REF, newSuperTypeRef, newSuperTypeRef));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EList<FieldDeclaration> getFieldDecls()
  {
    if (fieldDecls == null)
    {
      fieldDecls = new EObjectContainmentEList<FieldDeclaration>(FieldDeclaration.class, this, XjavaPackage.TYPE_DECLARATION__FIELD_DECLS);
    }
    return fieldDecls;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EList<MethodDeclaration> getMethodDecls()
  {
    if (methodDecls == null)
    {
      methodDecls = new EObjectContainmentEList<MethodDeclaration>(MethodDeclaration.class, this, XjavaPackage.TYPE_DECLARATION__METHOD_DECLS);
    }
    return methodDecls;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case XjavaPackage.TYPE_DECLARATION__SUPER_TYPE_REF:
        return basicSetSuperTypeRef(null, msgs);
      case XjavaPackage.TYPE_DECLARATION__FIELD_DECLS:
        return ((InternalEList<?>)getFieldDecls()).basicRemove(otherEnd, msgs);
      case XjavaPackage.TYPE_DECLARATION__METHOD_DECLS:
        return ((InternalEList<?>)getMethodDecls()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case XjavaPackage.TYPE_DECLARATION__NAME:
        return getName();
      case XjavaPackage.TYPE_DECLARATION__SUPER_TYPE_REF:
        return getSuperTypeRef();
      case XjavaPackage.TYPE_DECLARATION__FIELD_DECLS:
        return getFieldDecls();
      case XjavaPackage.TYPE_DECLARATION__METHOD_DECLS:
        return getMethodDecls();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case XjavaPackage.TYPE_DECLARATION__NAME:
        setName((String)newValue);
        return;
      case XjavaPackage.TYPE_DECLARATION__SUPER_TYPE_REF:
        setSuperTypeRef((TypeReference)newValue);
        return;
      case XjavaPackage.TYPE_DECLARATION__FIELD_DECLS:
        getFieldDecls().clear();
        getFieldDecls().addAll((Collection<? extends FieldDeclaration>)newValue);
        return;
      case XjavaPackage.TYPE_DECLARATION__METHOD_DECLS:
        getMethodDecls().clear();
        getMethodDecls().addAll((Collection<? extends MethodDeclaration>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case XjavaPackage.TYPE_DECLARATION__NAME:
        setName(NAME_EDEFAULT);
        return;
      case XjavaPackage.TYPE_DECLARATION__SUPER_TYPE_REF:
        setSuperTypeRef((TypeReference)null);
        return;
      case XjavaPackage.TYPE_DECLARATION__FIELD_DECLS:
        getFieldDecls().clear();
        return;
      case XjavaPackage.TYPE_DECLARATION__METHOD_DECLS:
        getMethodDecls().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case XjavaPackage.TYPE_DECLARATION__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case XjavaPackage.TYPE_DECLARATION__SUPER_TYPE_REF:
        return superTypeRef != null;
      case XjavaPackage.TYPE_DECLARATION__FIELD_DECLS:
        return fieldDecls != null && !fieldDecls.isEmpty();
      case XjavaPackage.TYPE_DECLARATION__METHOD_DECLS:
        return methodDecls != null && !methodDecls.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(')');
    return result.toString();
  }

} //TypeDeclarationImpl
